Skip to content

# Interface: SelectProps<T>

Renderer.Component.SelectProps

## Type parameters

Name | Type
--- | ---
`T` | `T` = `any`

## Hierarchy

- `ReactSelectProps`<T, boolean>

- `CreatableProps`<T, boolean>

↳ SelectProps

## Table of contents

### Properties

- allowCreateWhileLoading
- aria-label
- aria-labelledby
- autoConvertOptions
- autoFocus
- backspaceRemovesValue
- blurInputOnSelect
- captureMenuScroll
- className
- classNamePrefix
- closeMenuOnScroll
- closeMenuOnSelect
- components
- controlShouldRenderValue
- createOptionPosition
- defaultInputValue
- defaultMenuIsOpen
- defaultValue
- delimiter
- escapeClearsValue
- filterOption
- formatCreateLabel
- formatGroupLabel
- formatOptionLabel
- getNewOptionData
- getOptionLabel
- getOptionValue
- hideSelectedOptions
- id
- inputId
- inputValue
- instanceId
- isClearable
- isCreatable
- isDisabled
- isLoading
- isMulti
- isOptionDisabled
- isOptionSelected
- isRtl
- isSearchable
- isValidNewOption
- loadingMessage
- maxMenuHeight
- menuClass
- menuIsOpen
- menuPlacement
- menuPortalTarget
- menuPosition
- menuShouldBlockScroll
- menuShouldScrollIntoView
- minMenuHeight
- name
- noOptionsMessage
- onBlur
- onCreateOption
- onFocus
- onInputChange
- onKeyDown
- onMenuClose
- onMenuOpen
- onMenuScrollToBottom
- onMenuScrollToTop
- openMenuOnClick
- openMenuOnFocus
- options
- pageSize
- placeholder
- screenReaderStatus
- styles
- tabIndex
- tabSelectsValue
- theme
- themeName
- value

### Methods

- onChange

## Properties

### allowCreateWhileLoading

• `Optional` allowCreateWhileLoading: `boolean`

#### Inherited from

CreatableProps.allowCreateWhileLoading

### aria-label

• `Optional` aria-label: `string`

#### Inherited from

ReactSelectProps.aria-label

### aria-labelledby

• `Optional` aria-labelledby: `string`

#### Inherited from

ReactSelectProps.aria-labelledby

### autoConvertOptions

• `Optional` autoConvertOptions: `boolean`

### autoFocus

• `Optional` autoFocus: `boolean`

#### Inherited from

ReactSelectProps.autoFocus

### backspaceRemovesValue

• `Optional` backspaceRemovesValue: `boolean`

#### Inherited from

ReactSelectProps.backspaceRemovesValue

### blurInputOnSelect

• `Optional` blurInputOnSelect: `boolean`

#### Inherited from

ReactSelectProps.blurInputOnSelect

### captureMenuScroll

• `Optional` captureMenuScroll: `boolean`

#### Inherited from

ReactSelectProps.captureMenuScroll

### className

• `Optional` className: `string`

#### Inherited from

ReactSelectProps.className

### classNamePrefix

• `Optional` classNamePrefix: `string`

#### Inherited from

ReactSelectProps.classNamePrefix

### closeMenuOnScroll

• `Optional` closeMenuOnScroll: `boolean` | `EventListener`

#### Inherited from

ReactSelectProps.closeMenuOnScroll

### closeMenuOnSelect

• `Optional` closeMenuOnSelect: `boolean`

#### Inherited from

ReactSelectProps.closeMenuOnSelect

### components

• `Optional` components: `Partial`<SelectComponents<T, boolean>>

#### Inherited from

ReactSelectProps.components

### controlShouldRenderValue

• `Optional` controlShouldRenderValue: `boolean`

#### Inherited from

ReactSelectProps.controlShouldRenderValue

### createOptionPosition

• `Optional` createOptionPosition: `"first"` | `"last"`

#### Inherited from

CreatableProps.createOptionPosition

### defaultInputValue

• `Optional` defaultInputValue: `string`

#### Inherited from

ReactSelectProps.defaultInputValue

### defaultMenuIsOpen

• `Optional` defaultMenuIsOpen: `boolean`

#### Inherited from

ReactSelectProps.defaultMenuIsOpen

### defaultValue

• `Optional` defaultValue: `T` | `OptionsType`<T>

#### Inherited from

ReactSelectProps.defaultValue

### delimiter

• `Optional` delimiter: `string`

#### Inherited from

ReactSelectProps.delimiter

### escapeClearsValue

• `Optional` escapeClearsValue: `boolean`

#### Inherited from

ReactSelectProps.escapeClearsValue

### filterOption

• `Optional` filterOption: (`option`: `Option`, `rawInput`: `string`) => `boolean`

#### Type declaration

▸ (`option`, `rawInput`): `boolean`

##### Parameters

Name | Type
--- | ---
`option` | `Option`
`rawInput` | `string`

##### Returns

`boolean`

#### Inherited from

ReactSelectProps.filterOption

### formatCreateLabel

• `Optional` formatCreateLabel: (`inputValue`: `string`) => `ReactNode`

#### Type declaration

▸ (`inputValue`): `ReactNode`

##### Parameters

Name | Type
--- | ---
`inputValue` | `string`

##### Returns

`ReactNode`

#### Inherited from

CreatableProps.formatCreateLabel

### formatGroupLabel

• `Optional` formatGroupLabel: `formatGroupLabel`<T>

#### Inherited from

ReactSelectProps.formatGroupLabel

### formatOptionLabel

• `Optional` formatOptionLabel: (`option`: `T`, `labelMeta`: `FormatOptionLabelMeta`) => `ReactNode`

#### Type declaration

▸ (`option`, `labelMeta`): `ReactNode`

##### Parameters

Name | Type
--- | ---
`option` | `T`
`labelMeta` | `FormatOptionLabelMeta`<T, boolean>

##### Returns

`ReactNode`

#### Inherited from

ReactSelectProps.formatOptionLabel

### getNewOptionData

• `Optional` getNewOptionData: (`inputValue`: `string`, `optionLabel`: `ReactNode`) => `T`

#### Type declaration

▸ (`inputValue`, `optionLabel`): `T`

##### Parameters

Name | Type
--- | ---
`inputValue` | `string`
`optionLabel` | `ReactNode`

##### Returns

`T`

#### Inherited from

CreatableProps.getNewOptionData

### getOptionLabel

• `Optional` getOptionLabel: `getOptionLabel`<T>

#### Inherited from

ReactSelectProps.getOptionLabel

### getOptionValue

• `Optional` getOptionValue: `getOptionValue`<T>

#### Inherited from

ReactSelectProps.getOptionValue

### hideSelectedOptions

• `Optional` hideSelectedOptions: `boolean`

#### Inherited from

ReactSelectProps.hideSelectedOptions

### id

• `Optional` id: `string`

#### Inherited from

ReactSelectProps.id

### inputId

• `Optional` inputId: `string`

#### Inherited from

ReactSelectProps.inputId

### inputValue

• `Optional` inputValue: `string`

#### Inherited from

ReactSelectProps.inputValue

### instanceId

• `Optional` instanceId: `string` | `number`

#### Inherited from

ReactSelectProps.instanceId

### isClearable

• `Optional` isClearable: `boolean`

#### Inherited from

ReactSelectProps.isClearable

### isCreatable

• `Optional` isCreatable: `boolean`

### isDisabled

• `Optional` isDisabled: `boolean`

#### Inherited from

ReactSelectProps.isDisabled

### isLoading

• `Optional` isLoading: `boolean`

#### Inherited from

ReactSelectProps.isLoading

### isMulti

• `Optional` isMulti: `boolean`

#### Inherited from

ReactSelectProps.isMulti

### isOptionDisabled

• `Optional` isOptionDisabled: (`option`: `T`, `options`: `OptionsType`) => `boolean`

#### Type declaration

▸ (`option`, `options`): `boolean`

##### Parameters

Name | Type
--- | ---
`option` | `T`
`options` | `OptionsType`<T>

##### Returns

`boolean`

#### Inherited from

ReactSelectProps.isOptionDisabled

### isOptionSelected

• `Optional` isOptionSelected: (`option`: `T`, `options`: `OptionsType`) => `boolean`

#### Type declaration

▸ (`option`, `options`): `boolean`

##### Parameters

Name | Type
--- | ---
`option` | `T`
`options` | `OptionsType`<T>

##### Returns

`boolean`

#### Inherited from

ReactSelectProps.isOptionSelected

### isRtl

• `Optional` isRtl: `boolean`

#### Inherited from

ReactSelectProps.isRtl

### isSearchable

• `Optional` isSearchable: `boolean`

#### Inherited from

ReactSelectProps.isSearchable

### isValidNewOption

• `Optional` isValidNewOption: (`inputValue`: `string`, `value`: `T` | `OptionsType`<T>, `options`: `OptionsType`<T> | `GroupedOptionsType`) => `boolean`

#### Type declaration

▸ (`inputValue`, `value`, `options`): `boolean`

##### Parameters

Name | Type
--- | ---
`inputValue` | `string`
`value` | `T` | `OptionsType`<T>
`options` | `OptionsType`<T> | `GroupedOptionsType`<T>

##### Returns

`boolean`

#### Inherited from

CreatableProps.isValidNewOption

### loadingMessage

• `Optional` loadingMessage: (`obj`: { `inputValue`: `string` }) => `string`

#### Type declaration

▸ (`obj`): `string`

##### Parameters

Name | Type
--- | ---
`obj` | `Object`
`obj.inputValue` | `string`

##### Returns

`string`

#### Inherited from

ReactSelectProps.loadingMessage

### maxMenuHeight

• `Optional` maxMenuHeight: `number`

#### Inherited from

ReactSelectProps.maxMenuHeight

### menuClass

• `Optional` menuClass: `string`

### menuIsOpen

• `Optional` menuIsOpen: `boolean`

#### Inherited from

ReactSelectProps.menuIsOpen

### menuPlacement

• `Optional` menuPlacement: `MenuPlacement`

#### Inherited from

ReactSelectProps.menuPlacement

### menuPortalTarget

• `Optional` menuPortalTarget: `HTMLElement`

#### Inherited from

ReactSelectProps.menuPortalTarget

### menuPosition

• `Optional` menuPosition: `MenuPosition`

#### Inherited from

ReactSelectProps.menuPosition

### menuShouldBlockScroll

• `Optional` menuShouldBlockScroll: `boolean`

#### Inherited from

ReactSelectProps.menuShouldBlockScroll

### menuShouldScrollIntoView

• `Optional` menuShouldScrollIntoView: `boolean`

#### Inherited from

ReactSelectProps.menuShouldScrollIntoView

### minMenuHeight

• `Optional` minMenuHeight: `number`

#### Inherited from

ReactSelectProps.minMenuHeight

### name

• `Optional` name: `string`

#### Inherited from

ReactSelectProps.name

### noOptionsMessage

• `Optional` noOptionsMessage: (`obj`: { `inputValue`: `string` }) => `string`

#### Type declaration

▸ (`obj`): `string`

##### Parameters

Name | Type
--- | ---
`obj` | `Object`
`obj.inputValue` | `string`

##### Returns

`string`

#### Inherited from

ReactSelectProps.noOptionsMessage

### onBlur

• `Optional` onBlur: `FocusEventHandler`

#### Inherited from

ReactSelectProps.onBlur

### onCreateOption

• `Optional` onCreateOption: (`inputValue`: `string`) => `void`

#### Type declaration

▸ (`inputValue`): `void`

##### Parameters

Name | Type
--- | ---
`inputValue` | `string`

##### Returns

`void`

#### Inherited from

CreatableProps.onCreateOption

### onFocus

• `Optional` onFocus: `FocusEventHandler`

#### Inherited from

ReactSelectProps.onFocus

### onInputChange

• `Optional` onInputChange: (`newValue`: `string`, `actionMeta`: `InputActionMeta`) => `void`

#### Type declaration

▸ (`newValue`, `actionMeta`): `void`

##### Parameters

Name | Type
--- | ---
`newValue` | `string`
`actionMeta` | `InputActionMeta`

##### Returns

`void`

#### Inherited from

ReactSelectProps.onInputChange

### onKeyDown

• `Optional` onKeyDown: `KeyboardEventHandler`

#### Inherited from

ReactSelectProps.onKeyDown

### onMenuClose

• `Optional` onMenuClose: () => `void`

#### Type declaration

▸ (): `void`

##### Returns

`void`

#### Inherited from

ReactSelectProps.onMenuClose

### onMenuOpen

• `Optional` onMenuOpen: () => `void`

#### Type declaration

▸ (): `void`

##### Returns

`void`

#### Inherited from

ReactSelectProps.onMenuOpen

### onMenuScrollToBottom

• `Optional` onMenuScrollToBottom: (`event`: `SyntheticEvent`) => `void`

#### Type declaration

▸ (`event`): `void`

##### Parameters

Name | Type
--- | ---
`event` | `SyntheticEvent`<HTMLElement, Event>

##### Returns

`void`

#### Inherited from

ReactSelectProps.onMenuScrollToBottom

### onMenuScrollToTop

• `Optional` onMenuScrollToTop: (`event`: `SyntheticEvent`) => `void`

#### Type declaration

▸ (`event`): `void`

##### Parameters

Name | Type
--- | ---
`event` | `SyntheticEvent`<HTMLElement, Event>

##### Returns

`void`

#### Inherited from

ReactSelectProps.onMenuScrollToTop

### openMenuOnClick

• `Optional` openMenuOnClick: `boolean`

#### Inherited from

ReactSelectProps.openMenuOnClick

### openMenuOnFocus

• `Optional` openMenuOnFocus: `boolean`

#### Inherited from

ReactSelectProps.openMenuOnFocus

### options

• `Optional` options: `OptionsType`<T> | `GroupedOptionsType`<T>

#### Inherited from

ReactSelectProps.options

### pageSize

• `Optional` pageSize: `number`

#### Inherited from

ReactSelectProps.pageSize

### placeholder

• `Optional` placeholder: `ReactNode`

#### Inherited from

ReactSelectProps.placeholder

### screenReaderStatus

• `Optional` screenReaderStatus: (`obj`: { `count`: `number` }) => `string`

#### Type declaration

▸ (`obj`): `string`

##### Parameters

Name | Type
--- | ---
`obj` | `Object`
`obj.count` | `number`

##### Returns

`string`

#### Inherited from

ReactSelectProps.screenReaderStatus

### styles

• `Optional` styles: `Partial`<Styles<T, boolean>>

#### Inherited from

ReactSelectProps.styles

### tabIndex

• `Optional` tabIndex: `string`

#### Inherited from

ReactSelectProps.tabIndex

### tabSelectsValue

• `Optional` tabSelectsValue: `boolean`

#### Inherited from

ReactSelectProps.tabSelectsValue

### theme

• `Optional` theme: `ThemeConfig`

#### Inherited from

ReactSelectProps.theme

### themeName

• `Optional` themeName: `"lens"` | `"light"` | `"outlined"` | `"dark"`

### value

• `Optional` value: `T`

#### Overrides

ReactSelectProps.value

## Methods

### onChange

▸ `Optional` onChange(`option`, `meta?`): `void`

#### Parameters

Name | Type
--- | ---
`option` | `T`
`meta?` | `ActionMeta`<any>

#### Returns

`void`

#### Overrides

ReactSelectProps.onChange